/*
 * priority-nav - v1.3.1 | (c) 2020 @gijsroge | MIT license
 * Repository: https://github.com/gijsroge/priority-navigation.git
 * Description: Priority+ pattern navigation that hides menu items if they don't fit on screen.
 * Demo: http://gijsroge.github.io/priority-nav.js/
 */

!function(e,t){"function"==typeof define&&define.amd?define("priorityNav",t(e)):"object"==typeof exports?module.exports=t(e):e.priorityNav=t(e)}(window||this,function(e){"use strict";var i,d,c,l,u,a,s,p,v={},y=[],f=!!document.querySelector&&!!e.addEventListener,h={},m=0,w=0,L={initClass:"js-priorityNav",mainNavWrapper:"nav",mainNav:"ul",navDropdownClassName:"nav__dropdown",navDropdownToggleClassName:"nav__dropdown-toggle",navDropdownToggleAriaLabel:"More navigation options",navDropdownLabel:"More",navDropdownLabelActive:"Close",navDropdownBreakpointLabel:"menu",breakPoint:500,throttleDelay:50,offsetPixels:0,count:!0,moved:function(){},movedBack:function(){}},r=MouseEvent.prototype.hasOwnProperty("relatedTarget")?"focusout":"blur",b=function(e,t,n){if("[object Object]"===Object.prototype.toString.call(e))for(var o in e)Object.prototype.hasOwnProperty.call(e,o)&&t.call(n,e[o],o,e);else for(var r=0,i=e.length;r<i;r++)t.call(n,e[r],r,e)};var S=function(e,t){for(;null!==e;){if(e.parentNode===t)return!0;e=e.parentNode}return!1},g=function(e,t){if(e.classList)e.classList.toggle(t);else{var n=e.className.split(" "),o=n.indexOf(t);0<=o?n.splice(o,1):n.push(t),e.className=n.join(" ")}},q=function(e,t){e.classList?e.classList.remove(t):e.className=e.className.replace(new RegExp("s?"+t+"s?"),"")},N=function(e,t){e.classList?e.classList.add(t):e.className=e.className+" "+t},n=function(e){var t,n,o,r,i,a,s,l;t=e,n=window.getComputedStyle(t),o=parseFloat(n.paddingLeft)+parseFloat(n.paddingRight),d=t.clientWidth-o,e.querySelector(u).parentNode===e?e.querySelector(u).offsetWidth:0,c=A(e)+h.offsetPixels,w=(r=document,i=window,a=r.compatMode&&"CSS1Compat"===r.compatMode?r.documentElement:r.body,s=a.clientWidth,l=a.clientHeight,i.innerWidth&&s>i.innerWidth&&(s=i.innerWidth,l=i.innerHeight),{width:s,height:l}).width};v.doesItFit=function(t){var o,r,i,a,s,e=0===t.getAttribute("instance")?e:h.throttleDelay;0,o=function(){var e=t.getAttribute("instance");for(n(t);d<=c&&0<t.querySelector(l).children.length||w<h.breakPoint&&0<t.querySelector(l).children.length;)v.toDropdown(t,e),n(t),w<h.breakPoint&&C(t,h.navDropdownBreakpointLabel);for(;d>=y[e][y[e].length-1]&&w>h.breakPoint;)v.toMenu(t,e),w>h.breakPoint&&C(t,h.navDropdownLabel);y[e].length<1&&(t.querySelector(u).classList.remove("show"),C(t,h.navDropdownLabel)),t.querySelector(l).children.length<1?(t.classList.add("is-empty"),C(t,h.navDropdownBreakpointLabel)):t.classList.remove("is-empty"),D(t,e)},r=e,function(){var e=this,t=arguments,n=i&&!a;clearTimeout(a),a=setTimeout(function(){a=null,i||o.apply(e,t)},r),n&&o.apply(e,t),clearTimeout(s),s=setTimeout(function(){o.apply(e,t)},800)}()};var D=function(e,t){y[t].length<1?(e.querySelector(a).classList.add("priority-nav-is-hidden"),e.querySelector(a).classList.remove("priority-nav-is-visible"),e.classList.remove("priority-nav-has-dropdown"),e.querySelector(".priority-nav__wrapper").setAttribute("aria-haspopup","false")):(e.querySelector(a).classList.add("priority-nav-is-visible"),e.querySelector(a).classList.remove("priority-nav-is-hidden"),e.classList.add("priority-nav-has-dropdown"),e.querySelector(".priority-nav__wrapper").setAttribute("aria-haspopup","true"))},o=function(e,t){e.querySelector(a).setAttribute("priorityNav-count",y[t].length)},C=function(e,t){(e.querySelector(a).innerHTML=t)===h.navDropdownLabelActive?e.querySelector(a).setAttribute("aria-expanded","true"):e.querySelector(a).setAttribute("aria-expanded","false")};v.toDropdown=function(e,t){e.querySelector(u).firstChild&&0<e.querySelector(l).children.length?e.querySelector(u).insertBefore(e.querySelector(l).lastElementChild,e.querySelector(u).firstChild):0<e.querySelector(l).children.length&&e.querySelector(u).appendChild(e.querySelector(l).lastElementChild),y[t].push(c),D(e,t),0<e.querySelector(l).children.length&&h.count&&o(e,t),h.moved()},v.toMenu=function(e,t){0<e.querySelector(u).children.length&&e.querySelector(l).appendChild(e.querySelector(u).firstElementChild),y[t].pop(),D(e,t),0<e.querySelector(l).children.length&&h.count&&o(e,t),h.movedBack()};var A=function(e){for(var t=e.childNodes,n=0,o=0;o<t.length;o++)3!==t[o].nodeType&&(isNaN(t[o].offsetWidth)||(n+=t[o].offsetWidth));return n},E=function(t,n){window.attachEvent?window.attachEvent("onresize",function(){v.doesItFit&&v.doesItFit(t)}):window.addEventListener&&(window.addEventListener("resize",function(){v.doesItFit&&v.doesItFit(t)}),window.addEventListener("orientationchange",function(){v.doesItFit&&v.doesItFit(t)},!0)),t.querySelector(a).addEventListener("mousedown",function(e){e.stopPropagation(),g(t.querySelector(u),"show"),g(this,"is-open"),g(t,"is-open"),t.classList.contains("is-open")?(t.querySelector(u).setAttribute("aria-hidden","true"),C(t,n.navDropdownLabelActive),t.querySelector(u).blur()):(t.querySelector(u).setAttribute("aria-hidden","false"),C(t,n.navDropdownLabel))});var o=function(e){S(e.relatedTarget,p)||(q(t.querySelector(u),"show"),q(t.querySelector(a),"is-open"),q(t,"is-open"),C(t,n.navDropdownLabel),t.querySelector(u+" li:last-child a").removeEventListener(r,o))};t.querySelector(a).addEventListener("focus",function(e){-1===t.className.indexOf("is-open")&&(N(t.querySelector(u),"show"),N(this,"is-open"),N(t,"is-open"),C(t,n.navDropdownLabelActive),t.querySelector(u).setAttribute("aria-hidden","false"),t.querySelector(u).blur())}),t.querySelector(a).addEventListener(r,function(e){S(e.relatedTarget,p)?document.querySelector(u+" li:last-child a").addEventListener(r,o):(document.querySelector(u+" li:last-child a").removeEventListener(r,o),q(t.querySelector(u),"show"),q(this,"is-open"),q(t,"is-open"),C(t,n.navDropdownLabel),t.querySelector(u).setAttribute("aria-hidden","false"))}),document.addEventListener("click",function(e){(function(e,t){for(var n=t.charAt(0);e&&e!==document;e=e.parentNode)if("."===n){if(e.classList.contains(t.substr(1)))return e}else if("#"===n){if(e.id===t.substr(1))return e}else if("["===n&&e.hasAttribute(t.substr(1,t.length-2)))return e;return!1})(e.target,"."+n.navDropdownClassName)||e.target===t.querySelector(a)||(t.querySelector(u).classList.remove("show"),t.querySelector(a).classList.remove("is-open"),t.classList.remove("is-open"),C(t,n.navDropdownLabel))}),document.onkeydown=function(e){27===(e=e||window.event).keyCode&&(document.querySelector(u).classList.remove("show"),document.querySelector(a).classList.remove("is-open"),i.classList.remove("is-open"))}};Element.prototype.remove=function(){this.parentElement.removeChild(this)},NodeList.prototype.remove=HTMLCollection.prototype.remove=function(){for(var e=0,t=this.length;e<t;e++)this[e]&&this[e].parentElement&&this[e].parentElement.removeChild(this[e])},v.destroy=function(){h&&(document.documentElement.classList.remove(h.initClass),p.remove(),h=null,delete v.init,delete v.doesItFit)},f&&"undefined"!=typeof Node&&(Node.prototype.insertAfter=function(e,t){this.insertBefore(e,t.nextSibling)});var T=function(e){var t=e.charAt(0);return"."!==t&&"#"!==t};return v.init=function(e){var n,o,r;if(o=e||{},r={},b(n=L,function(e,t){r[t]=n[t]}),b(o,function(e,t){r[t]=o[t]}),h=r,f||"undefined"!=typeof Node)if(T(h.navDropdownClassName)&&T(h.navDropdownToggleClassName)){var t=document.querySelectorAll(h.mainNavWrapper);b(t,function(e){var t,n;(y[m]=[],e.setAttribute("instance",m++),i=e)?(l=h.mainNav,e.querySelector(l)?(t=e,n=h,p=document.createElement("span"),u=document.createElement("ul"),a=document.createElement("button"),s=document.createElement("span"),a.innerHTML=n.navDropdownLabel,s.innerHTML=n.navDropdownToggleAriaLabel,a.setAttribute("aria-expanded","false"),a.setAttribute("type","button"),a.setAttribute("aria-labelledby","priorityNavLabel"),s.setAttribute("id","priorityNavLabel"),u.setAttribute("aria-hidden","true"),t.querySelector(l).parentNode===t?(t.insertAfter(p,t.querySelector(l)),p.appendChild(s),p.appendChild(a),p.appendChild(u),u.classList.add(n.navDropdownClassName),u.classList.add("priority-nav__dropdown"),a.classList.add(n.navDropdownToggleClassName),a.classList.add("priority-nav__dropdown-toggle"),a.setAttribute("type","button"),p.classList.add(n.navDropdownClassName+"-wrapper"),p.classList.add("priority-nav__wrapper"),t.classList.add("priority-nav")):console.warn("mainNav is not a direct child of mainNavWrapper, double check please"),u="."+h.navDropdownClassName,e.querySelector(u)?(a="."+h.navDropdownToggleClassName,e.querySelector(a)?(E(e,h),v.doesItFit(e)):console.warn("couldn't find the specified navDropdownToggle element")):console.warn("couldn't find the specified navDropdown element")):console.warn("couldn't find the specified mainNav element")):console.warn("couldn't find the specified mainNavWrapper element")}),0,document.documentElement.classList.add(h.initClass)}else console.warn("No symbols allowed in navDropdownClassName & navDropdownToggleClassName. These are not selectors.");else console.warn("This browser doesn't support priorityNav")},v});